program main
    use dg

    implicit none

    integer :: n, k
    real(dp) :: time, cfl
    real(dp), allocatable :: x(:), dx(:), u(:,:), P(:,:)
    real :: t1, t2
    n = 80
    k = 3
    time = 1._dp
    !cfl = (0.1_dp)**k
    cfl = (0.1_dp)**k
    if (allocated(P)) deallocate(P)
    allocate(P(k+1,k+1))
    if (allocated(u)) deallocate(u)
    allocate(u(k+1,n))
    if (allocated(x)) deallocate(x)
    allocate(x(n))
    if (allocated(dx)) deallocate(dx)
    allocate(dx(n))

    call cpu_time(t1)
    call dg_appr(n, k, cfl, time, x, dx, u, P)
    call cpu_time(t2)
    write (*,*) t2 - t1
    deallocate(P)
    deallocate(u)
    deallocate(x)
    deallocate(dx)
end program main
